; example on how to use NinjaTrackerPlus

NinjaTrackerPlus        =   $f0000
NTPprepare              =   NinjaTrackerPlus
NTPplay                 =   NinjaTrackerPlus+3
NTPstop                 =   NinjaTrackerPlus+6
NTPgetvuptr             =   NinjaTrackerPlus+9
NTPgete8ptr             =   NinjaTrackerPlus+12
NTPforcesongpos         =   NinjaTrackerPlus+15
NTPgetsongpos           =   NinjaTrackerPlus+18
NTPsetplayvolume        =   NinjaTrackerPlus+21
NTPstreamsound          =   NinjaTrackerPlus+24

song_ptr                =   $100000
sound_ptr               =   $e0000

                        dsk ntpcall
                        org $300

                        jmp start_music         ;this is started by the caller
                        jmp stop_music          ;type "call 771" to stop music
                        jmp stream_sound        ;type "call 774" from basic to stream a sound

;--------------------------

start_music             = *
                        clc
                        xce
                        rep #$30
                        mx  %00

                        ldx #song_ptr
                        ldy #^song_ptr
                        lda #1                  ;try to use channel doubling
                        jsl NTPprepare
                        bcc no_error

                        cmp #3                  ;if the error code is 3, then channel doubling is not possible
                        bne error

                        ldx #song_ptr
                        ldy #^song_ptr
                        lda #0                  ;play withing channel doubling
                        jsl NTPprepare
                        bcs error

no_error                = *
                        lda #180                ;limit volume
                        jsl NTPsetplayvolume

                        lda #1                  ;play song only once
                        jsl NTPplay

                        sec
                        xce
                        sep #$30
                        rtl                     ;rtl because of our caller

;--------------------------

error                   = *
                        mx  %00
                        ldx #$dead              ;there has been an error
                        txy
                        brk 0                   ;die here

;--------------------------

stop_music              = *
                        clc
                        xce
                        rep #$30
                        mx  %00
                        
                        jsl NTPstop

                        sec
                        xce
                        sep #$30
                        rts

;--------------------------

stream_sound            = *                     ;sample code to stream a sample
                        clc
                        xce
                        rep #$30
                        mx  %00

                        ldx #stream_sound_structure
                        ldy #^stream_sound_structure
                        jsl NTPstreamsound

                        sec
                        xce
                        sep #$30
                        rts

stream_sound_structure  = *
                        adrl sound_ptr          ;pointer to where the wave is in ram
                        adrl 48677              ;length of wave, including 8 stopper bytes
                        dw $180                 ;frequency
                        dfb $f0                 ;place the 512 byte stream buffer at $F000-$F1FF in doc ram
                        dfb 28                  ;use osc. 28 (interrupt), 29 (play left), 30 (play right)
                        dfb 2                   ;use 2 oscillators for playing the sample
                        dfb 255                 ;use max volume for
                        dfb $00                 ;left speaker
                        dfb 128                 ;use half volume for
                        dfb $10                 ;right speaker
